<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>print() for C++20: include/print_atom.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">print() for C++20
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">print_atom.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;<a class="el" href="print__options_8h_source.html">print_options.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="print__concepts_8h_source.html">print_concepts.h</a>&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for print_atom.h:</div>
<div class="dyncontent">
<div class="center"><img src="print__atom_8h__incl.png" border="0" usemap="#include_2print__atom_8h" alt=""/></div>
<map name="include_2print__atom_8h" id="include_2print__atom_8h">
<area shape="rect" title=" " alt="" coords="198,5,354,32"/>
<area shape="rect" href="print__options_8h.html" title=" " alt="" coords="330,80,449,107"/>
<area shape="rect" href="print__concepts_8h.html" title=" " alt="" coords="35,155,165,181"/>
<area shape="rect" title=" " alt="" coords="424,229,483,256"/>
<area shape="rect" title=" " alt="" coords="593,155,669,181"/>
<area shape="rect" title=" " alt="" coords="189,155,264,181"/>
<area shape="rect" title=" " alt="" coords="288,155,365,181"/>
<area shape="rect" href="terminalcolors_8h.html" title=" " alt="" coords="389,155,517,181"/>
<area shape="rect" title=" " alt="" coords="272,229,352,256"/>
<area shape="rect" title=" " alt="" coords="5,229,85,256"/>
<area shape="rect" title=" " alt="" coords="109,229,200,256"/>
</map>
</div>
</div><div class="textblock"><div class="dynheader">
This graph shows which files directly or indirectly include this file:</div>
<div class="dyncontent">
<div class="center"><img src="print__atom_8h__dep__incl.png" border="0" usemap="#include_2print__atom_8hdep" alt=""/></div>
<map name="include_2print__atom_8hdep" id="include_2print__atom_8hdep">
<area shape="rect" title=" " alt="" coords="117,5,273,32"/>
<area shape="rect" href="print_8h.html" title=" " alt="" coords="137,80,252,107"/>
<area shape="rect" href="print__ostream_8h.html" title=" " alt="" coords="5,155,181,181"/>
<area shape="rect" href="print__shortcuts_8h.html" title=" " alt="" coords="206,155,389,181"/>
</map>
</div>
</div>
<p><a href="print__atom_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ad47012d4b2f909cec110fa350eae7192"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:ad47012d4b2f909cec110fa350eae7192"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__atom_8h.html#ad47012d4b2f909cec110fa350eae7192">print_atom</a> (std::ostream &amp;out, const PrintOptions &amp;, const T &amp;)</td></tr>
<tr class="memdesc:ad47012d4b2f909cec110fa350eae7192"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prints single object. Fallback for all other objects.  <a href="print__atom_8h.html#ad47012d4b2f909cec110fa350eae7192">More...</a><br /></td></tr>
<tr class="separator:ad47012d4b2f909cec110fa350eae7192"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a08a0df05930aa51f1c30e856b5e6ff99"><td class="memTemplParams" colspan="2">template&lt;concepts::Printable T&gt; </td></tr>
<tr class="memitem:a08a0df05930aa51f1c30e856b5e6ff99"><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__atom_8h.html#a08a0df05930aa51f1c30e856b5e6ff99">requires</a> (concepts::PrintableInteger&lt; T &gt;==false) &amp;&amp;(concepts</td></tr>
<tr class="memdesc:a08a0df05930aa51f1c30e856b5e6ff99"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prints single object. Use default operator&lt;&lt; if defined.  <a href="print__atom_8h.html#a08a0df05930aa51f1c30e856b5e6ff99">More...</a><br /></td></tr>
<tr class="separator:a08a0df05930aa51f1c30e856b5e6ff99"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Defines functions for printing individual objects (as opposed to containers like lists). The appropriate print function will be statically resolved using templates with concepts. </p>
</div><h2 class="groupheader">Function Documentation</h2>
<a id="ad47012d4b2f909cec110fa350eae7192"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad47012d4b2f909cec110fa350eae7192">&#9670;&nbsp;</a></span>print_atom()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void cpp20print::printing::detail::print_atom </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a> &amp;&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prints single object. Fallback for all other objects. </p>

</div>
</div>
<a id="a08a0df05930aa51f1c30e856b5e6ff99"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a08a0df05930aa51f1c30e856b5e6ff99">&#9670;&nbsp;</a></span>requires()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">cpp20print::printing::detail::requires </td>
          <td>(</td>
          <td class="paramtype">concepts::PrintableInteger&lt; T &gt;&#160;</td>
          <td class="paramname"> = <code>=&#160;false</code></td><td>)</td>
          <td> &amp;&amp;</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Prints single object. Use default operator&lt;&lt; if defined. </p>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
